Package: jsutils
Title: 'JavaScript' Utilities for 'R'
Version: 0.3.0
Authors@R: 
    person(c("Andrew", "R."), "Johnson", , "andrew.johnson@arjohnsonau.com", role = c("aut", "cre"),
           comment = c(ORCID = "0000-0001-7000-8065"))
Description: A collection of popular/useful JavaScript utilities, including the
    terser minifier, sass compiler, typescript transpiler, and more.
License: MIT + file LICENSE
Encoding: UTF-8
RoxygenNote: 7.3.3
Imports: QuickJSR (>= 1.8.1)
URL: https://github.com/andrjohns/jsutils,
        https://andrjohns.github.io/jsutils/
NeedsCompilation: no
Packaged: 2026-05-17 05:34:45 UTC; andrew
Author: Andrew R. Johnson [aut, cre] (ORCID:
    <https://orcid.org/0000-0001-7000-8065>)
Maintainer: Andrew R. Johnson <andrew.johnson@arjohnsonau.com>
Repository: CRAN
Date/Publication: 2026-05-17 06:00:02 UTC
Built: R 4.5.2; ; 2026-05-17 06:30:03 UTC; unix

Package: jsutils
Title: 'JavaScript' Utilities for 'R'
Version: 0.3.0
Authors@R: 
    person(c("Andrew", "R."), "Johnson", , "andrew.johnson@arjohnsonau.com", role = c("aut", "cre"),
           comment = c(ORCID = "0000-0001-7000-8065"))
Description: A collection of popular/useful JavaScript utilities, including the
    terser minifier, sass compiler, typescript transpiler, and more.
License: MIT + file LICENSE
Encoding: UTF-8
RoxygenNote: 7.3.3
Imports: QuickJSR (>= 1.8.1)
URL: https://github.com/andrjohns/jsutils,
        https://andrjohns.github.io/jsutils/
NeedsCompilation: no
Packaged: 2026-05-17 05:34:45 UTC; andrew
Author: Andrew R. Johnson [aut, cre] (ORCID:
    <https://orcid.org/0000-0001-7000-8065>)
Maintainer: Andrew R. Johnson <andrew.johnson@arjohnsonau.com>
Repository: CRAN
Date/Publication: 2026-05-17 06:00:02 UTC
Built: R 4.6.0; ; 2026-05-17 06:44:04 UTC; unix

<!-- README.md is generated from README.Rmd. Please edit that file -->

# jsutils

<!-- badges: start -->

<!-- badges: end -->

The `jsutils` package provides a portable collection of JavaScript
utility functions and libraries for R users. The package currently
provides bindings to the following JavaScript libraries:

- `esprima`: Tokeniser and Parser for JavaScript
- `sass`: A CSS preprocessor, compiling SCSS or SASS files to CSS
- `terser`: A minifier/mangler for JavaScript code
- `typescript`: A superset of JavaScript that compiles to clean
  JavaScript output

## Installation

You can install the development version of jsutils from
[GitHub](https://github.com/) with:

``` r
# install.packages("pak")
pak::pak("andrjohns/jsutils")
```

## Example

### `sass`: A CSS preprocessor

The `sass` function compiles SCSS or SASS code to CSS:

``` r
library(jsutils)

scss_code <- "h1 { font-size: 40px; code { font-face: Roboto Mono; } }"

# Compile SCSS code to CSS
sass(scss_code)
#> $css
#> [1] "h1 {\n  font-size: 40px;\n}\nh1 code {\n  font-face: Roboto Mono;\n}"
#> 
#> $loadedUrls
#> logical(0)

# With options
sass(scss_code, options = list(style = "compressed"))
#> $css
#> [1] "h1{font-size:40px}h1 code{font-face:Roboto Mono}"
#> 
#> $loadedUrls
#> logical(0)
```

### `terser`: A minifier/mangler for JavaScript code

The `terser` function minifies JavaScript code:

``` r
js_code <- "function hello() { console.log('Hello, world!'); }"

# Minify JavaScript code
terser(js_code)
#> $code
#> [1] "function hello(){console.log(\"Hello, world!\")}"

# With options
terser(js_code, list(mangle=list(toplevel = TRUE)))
#> $code
#> [1] "function o(){console.log(\"Hello, world!\")}"
```

### `typescript`: A superset of JavaScript that compiles to clean JavaScript output

The `typescript` function compiles TypeScript code to JavaScript:

``` r
ts_code <- "let arrow_func = (msg: string): void => { console.log(msg); };"

# Compile TypeScript code to JavaScript
typescript(ts_code)
#> $outputText
#> [1] "var arrow_func = function (msg) { console.log(msg); };\n"
#> 
#> $diagnostics
#> logical(0)
#> 
#> $sourceMapText
#> NULL

# With options
typescript(ts_code, options = list(compilerOptions = list(target = "ES2015")))
#> $outputText
#> [1] "let arrow_func = (msg) => { console.log(msg); };\n"
#> 
#> $diagnostics
#> logical(0)
#> 
#> $sourceMapText
#> NULL
```

### `esprima`: Tokeniser and Parser for JavaScript

Separate `esprima_parse` and `esprima_tokenize` functions are provided
to parse or tokenize JavaScript code respectively:

``` r
js_code <- "function hello() { console.log('Hello, world!'); }"

# Parse JavaScript code
esprima_parse(js_code)
#> $type
#> [1] "Program"
#> 
#> $body
#> $body[[1]]
#> $body[[1]]$type
#> [1] "FunctionDeclaration"
#> 
#> $body[[1]]$id
#> $body[[1]]$id$type
#> [1] "Identifier"
#> 
#> $body[[1]]$id$name
#> [1] "hello"
#> 
#> 
#> $body[[1]]$params
#> logical(0)
#> 
#> $body[[1]]$body
#> $body[[1]]$body$type
#> [1] "BlockStatement"
#> 
#> $body[[1]]$body$body
#> $body[[1]]$body$body[[1]]
#> $body[[1]]$body$body[[1]]$type
#> [1] "ExpressionStatement"
#> 
#> $body[[1]]$body$body[[1]]$expression
#> $body[[1]]$body$body[[1]]$expression$type
#> [1] "CallExpression"
#> 
#> $body[[1]]$body$body[[1]]$expression$callee
#> $body[[1]]$body$body[[1]]$expression$callee$type
#> [1] "MemberExpression"
#> 
#> $body[[1]]$body$body[[1]]$expression$callee$computed
#> [1] FALSE
#> 
#> $body[[1]]$body$body[[1]]$expression$callee$object
#> $body[[1]]$body$body[[1]]$expression$callee$object$type
#> [1] "Identifier"
#> 
#> $body[[1]]$body$body[[1]]$expression$callee$object$name
#> [1] "console"
#> 
#> 
#> $body[[1]]$body$body[[1]]$expression$callee$property
#> $body[[1]]$body$body[[1]]$expression$callee$property$type
#> [1] "Identifier"
#> 
#> $body[[1]]$body$body[[1]]$expression$callee$property$name
#> [1] "log"
#> 
#> 
#> 
#> $body[[1]]$body$body[[1]]$expression$arguments
#> $body[[1]]$body$body[[1]]$expression$arguments[[1]]
#> $body[[1]]$body$body[[1]]$expression$arguments[[1]]$type
#> [1] "Literal"
#> 
#> $body[[1]]$body$body[[1]]$expression$arguments[[1]]$value
#> [1] "Hello, world!"
#> 
#> $body[[1]]$body$body[[1]]$expression$arguments[[1]]$raw
#> [1] "'Hello, world!'"
#> 
#> 
#> 
#> 
#> 
#> 
#> 
#> $body[[1]]$generator
#> [1] FALSE
#> 
#> $body[[1]]$expression
#> [1] FALSE
#> 
#> $body[[1]]$async
#> [1] FALSE
#> 
#> 
#> 
#> $sourceType
#> [1] "script"

# Tokenize JavaScript code
esprima_tokenize(js_code)
#> [[1]]
#> [[1]]$type
#> [1] "Keyword"
#> 
#> [[1]]$value
#> [1] "function"
#> 
#> 
#> [[2]]
#> [[2]]$type
#> [1] "Identifier"
#> 
#> [[2]]$value
#> [1] "hello"
#> 
#> 
#> [[3]]
#> [[3]]$type
#> [1] "Punctuator"
#> 
#> [[3]]$value
#> [1] "("
#> 
#> 
#> [[4]]
#> [[4]]$type
#> [1] "Punctuator"
#> 
#> [[4]]$value
#> [1] ")"
#> 
#> 
#> [[5]]
#> [[5]]$type
#> [1] "Punctuator"
#> 
#> [[5]]$value
#> [1] "{"
#> 
#> 
#> [[6]]
#> [[6]]$type
#> [1] "Identifier"
#> 
#> [[6]]$value
#> [1] "console"
#> 
#> 
#> [[7]]
#> [[7]]$type
#> [1] "Punctuator"
#> 
#> [[7]]$value
#> [1] "."
#> 
#> 
#> [[8]]
#> [[8]]$type
#> [1] "Identifier"
#> 
#> [[8]]$value
#> [1] "log"
#> 
#> 
#> [[9]]
#> [[9]]$type
#> [1] "Punctuator"
#> 
#> [[9]]$value
#> [1] "("
#> 
#> 
#> [[10]]
#> [[10]]$type
#> [1] "String"
#> 
#> [[10]]$value
#> [1] "'Hello, world!'"
#> 
#> 
#> [[11]]
#> [[11]]$type
#> [1] "Punctuator"
#> 
#> [[11]]$value
#> [1] ")"
#> 
#> 
#> [[12]]
#> [[12]]$type
#> [1] "Punctuator"
#> 
#> [[12]]$value
#> [1] ";"
#> 
#> 
#> [[13]]
#> [[13]]$type
#> [1] "Punctuator"
#> 
#> [[13]]$value
#> [1] "}"
```

#' @title Compile SASS/SCSS to CSS using the sass.js library
#'
#' @description This function uses the sass.js library to compile SASS/SCSS code into CSS.
#' It leverages the QuickJSR package to run JavaScript code within R. Note that the
#' first time this function is called, it will load the sass.js library into the JavaScript context,
#' which may take a few seconds. Subsequent calls will be faster.
#'
#' @param input Either a path to a file or a character string containing the SASS/SCSS code to be compiled.
#' @param options A list of options to pass to the sass.js compiler.
#'
#' @return A list containing the compiled CSS code and any warnings or errors.
#' @examples
#' scss_code <- "h1 { font-size: 40px; code { font-face: Roboto Mono; } }"
#' sass(scss_code, list(style = "compressed"))
#'
#' @export
sass <- function(input, options = NULL) {
  if (file.exists(input)) {
    input <- paste(readLines(input, warn = FALSE), collapse = "\n")
  }
  if (!isTRUE(ctx_sass$get("sass_loaded"))) {
    # https://github.com/dart-lang/sdk/issues/27979
    ctx_sass$source(code=paste0("globalThis.location = { href: '", getwd(), "' };"))
    ctx_sass$source(system.file("js", paste0("sass.", .SASS_VERSION, ".js"), package = "jsutils", mustWork = TRUE))
    ctx_sass$assign("sass_loaded", TRUE)
  }
  res <- ctx_sass$call("sass.compileString", input, options)
  if (!is.null(res$error)) {
    stop(res$error$message, call. = FALSE)
  }
  res
}

.onLoad <- function(libname, pkgname) {
  for (lib in c("terser", "sass", "esprima", "typescript")) {
    assign(paste0("ctx_", lib), QuickJSR::JSContext$new(stack_size = 10 * 1024 * 1024), envir = topenv())
  }
}

#' @title Parse or Tokenize JavaScript code using Esprima
#' @name esprima
#'
#' @description Use the Esprima library to parse or tokenize JavaScript code. Note that the
#' first time this function is called, it will load the esprima library into the JavaScript context,
#' which may take a few seconds. Subsequent calls will be faster.
#'
#' @param input Either a path to a file or a character string containing the JavaScript code to be parsed or tokenized.
#' @param options A list of configuration options to pass to the Esprima parser or tokenizer.
#' @param type A character string specifying the type of code to parse: "script" (default) or "module".
#'
#' @return For `esprima_parse`, a list representing the Abstract Syntax Tree (AST) of the parsed code.
#' For `esprima_tokenize`, a list of tokens extracted from the input code.
#' @examples
#' js_code <- 'const answer = 42;'
#' esprima_parse(js_code)
#' esprima_tokenize(js_code)
NULL

#' @rdname esprima
#' @export
esprima_parse <- function(input, options = NULL, type = "script") {
  if (file.exists(input)) {
    input <- paste(readLines(input, warn = FALSE), collapse = "\n")
  }
  if (!(type %in% c("script", "module"))) {
    stop("type must be 'script' or 'module'", call. = FALSE)
  }
  if (!isTRUE(ctx_esprima$get("esprima_loaded"))) {
    ctx_esprima$source(system.file("js", paste0("esprima.", .ESPRIMA_VERSION, ".js"), package = "jsutils", mustWork = TRUE))
    ctx_esprima$assign("esprima_loaded", TRUE)
  }
  fun <- ifelse(type == "script", "esprima.parseScript", "esprima.parseModule")
  res <- ctx_esprima$call(fun, input, options)
  if (!is.null(res$error)) {
    stop(res$error$message, call. = FALSE)
  }
  res
}

#' @rdname esprima
#' @export
esprima_tokenize <- function(input, options = list()) {
  if (file.exists(input)) {
    input <- paste(readLines(input, warn = FALSE), collapse = "\n")
  }
  if (!isTRUE(ctx_esprima$get("esprima_loaded"))) {
    ctx_esprima$source(system.file("js", paste0("esprima.", .ESPRIMA_VERSION, ".js"), package = "jsutils", mustWork = TRUE))
    ctx_esprima$assign("esprima_loaded", TRUE)
  }
  res <- ctx_esprima$call("esprima.tokenize", input, options)
  if (!is.null(res$error)) {
    stop(res$error$message, call. = FALSE)
  }
  res
}

#' @title Transpile TypeScript code to JavaScript
#'
#' @description This function uses the TypeScript compiler to transpile TypeScript code into JavaScript. Note that the
#' first time this function is called, it will load the TypeScript library into the JavaScript context,
#' which may take a few seconds. Subsequent calls will be faster.
#'
#' @param input Either a path to a file or a character string containing the TypeScript code to be transpiled.
#' @param options A list of options to pass to the TypeScript transpiler. See the
#' [TypeScript documentation](https://www.typescriptlang.org/docs/handbook/compiler-options.html) for available options.
#'
#' @return A list containing the transpiled JavaScript code and any diagnostics.
#' @examples
#' ts_code <- "const greet = (name: string): string => `Hello, ${name}!`;"
#' typescript(ts_code, list(compilerOptions = list(target = "ES5")))
#'
#' @export
typescript <- function(input, options = NULL) {
  if (file.exists(input)) {
    input <- paste(readLines(input, warn = FALSE), collapse = "\n")
  }
  if (!isTRUE(ctx_typescript$get("typescript_loaded"))) {
    ctx_typescript$source(system.file("js", paste0("typescript.", .TYPESCRIPT_VERSION, ".js"), package = "jsutils", mustWork = TRUE))
    ctx_typescript$assign("typescript_loaded", TRUE)
  }
  res <- ctx_typescript$call("ts.transpileModule", input, options)
  if (!is.null(res$error)) {
    stop(res$error$message, call. = FALSE)
  }
  res
}

.ESPRIMA_VERSION <- "4.0.1"
.SASS_VERSION <- "1.99.0"
.TERSER_VERSION <- "5.47.1"
.TYPESCRIPT_VERSION <- "6.0.3"

#' Get versions of bundled JavaScript libraries
#'
#' This function returns the versions of the bundled JavaScript libraries used in the package.
#'
#' @return A named list with the versions of Esprima, sass.js, Terser, and TypeScript.
#' @examples
#' js_versions()
#' @export
js_versions <- function() {
  list(
    esprima = .ESPRIMA_VERSION,
    sass = .SASS_VERSION,
    terser = .TERSER_VERSION,
    typescript = .TYPESCRIPT_VERSION
  )
}

#' @title Minify JavaScript code using Terser
#'
#' @description Uses the Terser JavaScript library to minify JavaScript code. Note that the
#' first time this function is called, it will load the terser library into the JavaScript context,
#' which may take a few seconds. Subsequent calls will be faster.
#'
#' @param input Either a path to a file or a character string containing the JavaScript code to be minified.
#' @param options A list of options to pass to Terser for minification.
#' See the [Terser documentation](https://terser.org/docs/api-reference/#minify-options) for available options.
#'
#' @return A list containing the minified code and any warnings or errors.
#' @examples
#' js_code <- "function add(a, b) { return a + b; }"
#' terser(js_code, list(sourceMap = TRUE))
#'
#' @export
terser <- function(input, options = NULL) {
  if (file.exists(input)) {
    input <- paste(readLines(input, warn = FALSE), collapse = "\n")
  }
  if (!isTRUE(ctx_terser$get("terser_loaded"))) {
    ctx_terser$source(system.file("js", paste0("terser.", .TERSER_VERSION, ".js"), package = "jsutils", mustWork = TRUE))
    ctx_terser$assign("terser_loaded", TRUE)
  }
  res <- ctx_terser$call("terser.minify_sync", input, options)
  if (!is.null(res$error)) {
    stop(res$error$message, call. = FALSE)
  }
  res
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/esprima.R
\name{esprima}
\alias{esprima}
\alias{esprima_parse}
\alias{esprima_tokenize}
\title{Parse or Tokenize JavaScript code using Esprima}
\usage{
esprima_parse(input, options = NULL, type = "script")

esprima_tokenize(input, options = list())
}
\arguments{
\item{input}{Either a path to a file or a character string containing the JavaScript code to be parsed or tokenized.}

\item{options}{A list of configuration options to pass to the Esprima parser or tokenizer.}

\item{type}{A character string specifying the type of code to parse: "script" (default) or "module".}
}
\value{
For \code{esprima_parse}, a list representing the Abstract Syntax Tree (AST) of the parsed code.
For \code{esprima_tokenize}, a list of tokens extracted from the input code.
}
\description{
Use the Esprima library to parse or tokenize JavaScript code. Note that the
first time this function is called, it will load the esprima library into the JavaScript context,
which may take a few seconds. Subsequent calls will be faster.
}
\examples{
js_code <- 'const answer = 42;'
esprima_parse(js_code)
esprima_tokenize(js_code)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/sass.R
\name{sass}
\alias{sass}
\title{Compile SASS/SCSS to CSS using the sass.js library}
\usage{
sass(input, options = NULL)
}
\arguments{
\item{input}{Either a path to a file or a character string containing the SASS/SCSS code to be compiled.}

\item{options}{A list of options to pass to the sass.js compiler.}
}
\value{
A list containing the compiled CSS code and any warnings or errors.
}
\description{
This function uses the sass.js library to compile SASS/SCSS code into CSS.
It leverages the QuickJSR package to run JavaScript code within R. Note that the
first time this function is called, it will load the sass.js library into the JavaScript context,
which may take a few seconds. Subsequent calls will be faster.
}
\examples{
scss_code <- "h1 { font-size: 40px; code { font-face: Roboto Mono; } }"
sass(scss_code, list(style = "compressed"))

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/terser.R
\name{terser}
\alias{terser}
\title{Minify JavaScript code using Terser}
\usage{
terser(input, options = NULL)
}
\arguments{
\item{input}{Either a path to a file or a character string containing the JavaScript code to be minified.}

\item{options}{A list of options to pass to Terser for minification.
See the \href{https://terser.org/docs/api-reference/#minify-options}{Terser documentation} for available options.}
}
\value{
A list containing the minified code and any warnings or errors.
}
\description{
Uses the Terser JavaScript library to minify JavaScript code. Note that the
first time this function is called, it will load the terser library into the JavaScript context,
which may take a few seconds. Subsequent calls will be faster.
}
\examples{
js_code <- "function add(a, b) { return a + b; }"
terser(js_code, list(sourceMap = TRUE))

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/versions.R
\name{js_versions}
\alias{js_versions}
\title{Get versions of bundled JavaScript libraries}
\usage{
js_versions()
}
\value{
A named list with the versions of Esprima, sass.js, Terser, and TypeScript.
}
\description{
This function returns the versions of the bundled JavaScript libraries used in the package.
}
\examples{
js_versions()
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/typescript.R
\name{typescript}
\alias{typescript}
\title{Transpile TypeScript code to JavaScript}
\usage{
typescript(input, options = NULL)
}
\arguments{
\item{input}{Either a path to a file or a character string containing the TypeScript code to be transpiled.}

\item{options}{A list of options to pass to the TypeScript transpiler. See the
\href{https://www.typescriptlang.org/docs/handbook/compiler-options.html}{TypeScript documentation} for available options.}
}
\value{
A list containing the transpiled JavaScript code and any diagnostics.
}
\description{
This function uses the TypeScript compiler to transpile TypeScript code into JavaScript. Note that the
first time this function is called, it will load the TypeScript library into the JavaScript context,
which may take a few seconds. Subsequent calls will be faster.
}
\examples{
ts_code <- "const greet = (name: string): string => `Hello, ${name}!`;"
typescript(ts_code, list(compilerOptions = list(target = "ES5")))

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/jsutils-package.R
\docType{package}
\name{jsutils-package}
\alias{jsutils}
\alias{jsutils-package}
\title{jsutils: 'JavaScript' Utilities for 'R'}
\description{
A collection of popular/useful JavaScript utilities, including the terser minifier, sass compiler, typescript transpiler, and more.
}
\seealso{
Useful links:
\itemize{
  \item \url{https://github.com/andrjohns/QuickJSR}
  \item \url{https://andrjohns.github.io/jsutils/}
}

}
\author{
\strong{Maintainer}: Andrew R. Johnson \email{andrew.johnson@arjohnsonau.com} (\href{https://orcid.org/0000-0001-7000-8065}{ORCID})

}
\keyword{internal}
